<template lang="pug">
.row
  .gt-sm.col-sm-4.col-md-3
    LeaderBoard

  .col-12.col-sm-12.col-md-9
    //- div {{langs}}
    ModerationFilter(:terms="terms", useTarget="true", showLocked="true")
    FilterMessage(:terms="terms")
    .text-center(v-if="!filtered.length") {{ $t('no_tasks_match') }}
    q-infinite-scroll(
      scroll-target="body",
      ref="scroller",
      @load="onLoad",
      :offset="1000"
    )
      template(v-slot:loading)
        .row.justify-center.q-my-md
          q-spinner-dots(color="primary", size="40px")
      LangItem(
        v-for="(lang, index) in filtered",
        :config="config",
        :key="lang.id",
        :lang="lang",
        :user="user",
        v-on:needhelp="needHelp(lang)",
        v-on:lock="markAsActive(lang, index)",
        v-on:done="saveTranslation(lang)",
        v-on:youtube="openYouTube(lang)",
        v-on:unlock="unlock(lang)"
      )
        template(v-slot:score) {{ getScore(lang) }}
</template>

<script>
import LeaderBoard from "@/components/LeaderBoard";
import ModerationFilter from "@/components/ModerationFilter";
import FilterMessage from "@/components/FilterMessage";
import LangItem from "@/components/LangItem";
import { db, FieldValue } from "@/db";
import { filter, last, findIndex } from "lodash";
import Language from "@/mixins/Language";
import { mapState } from "vuex";
import { openURL } from "quasar";

export default {
  mixins: [Language],
  data: () => {
    return {
      terms: {
        showLocked: false,
      },
      langs: [],
      config: {},
    };
  },
  components: {
    LeaderBoard,
    ModerationFilter,
    FilterMessage,
    LangItem,
  },
  computed: {
    ...mapState({
      user: (state) => state.user,
    }),
    filtered() {
      return filter(this.langs, { status: "readyformanualtranslate" });
    },
  },
  watch: {
    terms: {
      deep: true,
      // immediate:true,
      async handler() {
        // console.log("terms trigger");
        this.langs = [];
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  methods: {
    async openYouTube(lang) {
      //get the youtube link:
      //TODO: set some kind of loading indicator:

      // console.log(lang.media);
      let media = (await db.doc(lang.media).get()).data();
      let youtubeid = media.youtube;
      openURL(`https://studio.youtube.com/video/${youtubeid}/translations`);
      //TODO: close some kind of loading indicator
    },
    getScore(lang) {
      return this.config.score_map[lang.type] || this.config.score_map["title"];
    },
    async needHelp(item) {
      // console.log("saving");
      Object.assign(item, {
        targetText: item.targetText || "",
        notes: this.$t("already_attempted_may_be_more_difficult"),
        activeUser: null,
        attemptedBy: `users/${this.user.id}`,
        attemptedAt: FieldValue.serverTimestamp(),
      });
      try {
        await db.collection("langs").doc(item.id).update(item);

        let index = findIndex(this.langs, { id: item.id });
        this.$set(this.langs, index, item);
      } catch (e) {
        this.showError(e);
      }
    },
    async saveTranslation(item) {
      try {
        if (
          (typeof item.targetText == "undefined" ||
            item.targetText.length == 0) &&
          typeof item.type == "undefined"
        )
          throw new Error(this.$t("no_text_entered"));
        Object.assign(item, {
          targetText: item.targetText || "",
          status: "readyforverify",
          activeUser: null,
          translatedBy: `users/${this.user.id}`,
          translatedAt: FieldValue.serverTimestamp(),
        });

        await db.collection("langs").doc(item.id).update(item);
      } catch (e) {
        this.showError(e);
      }
    },
    async unlock(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: null,
        markedActiveAt: null,
      });

      await db.collection("langs").doc(item.id).update({
        activeUser: null,
        markedActiveAt: null,
      });

      let index = findIndex(this.langs, { id: item.id });
      this.$set(this.langs, index, item);
    },
    async markAsActive(item) {
      // console.log("saving");
      Object.assign(item, {
        activeUser: `users/${this.user.id}`,
        markedActiveAt: FieldValue.serverTimestamp(),
      });

      await db.collection("langs").doc(item.id).update(item);

      let index = findIndex(this.langs, { id: item.id });

      this.$set(this.langs, index, item);
      // console.log(this.user.uid);
    },
    async onLoad(index, done) {
      // console.log("loading more", index);
      await this.getMedia(done);
    },
    async getMedia(done) {
      try {
        let ref = db
          .collection("langs")
          .where("status", "==", "readyformanualtranslate");

        //src lang
        if (this.terms.lang) {
          ref = ref.where("srcLang", "==", this.terms.lang);
        }

        if (this.terms.showLocked) {
          ref = ref.where("activeUser", "==", `users/${this.user.id}`);
        }

        if (this.terms.targetLang) {
          ref = ref.where("targetLang", "==", this.terms.targetLang);
        }

        ref = ref.orderBy("createdAt", "asc");

        if (this.langs.length > 0) {
          let lastl = last(this.langs);
          let lastref = lastl._doc;
          ref = ref.startAfter(lastref);
        }

        ref = ref.limit(10);

        await this.$bind("tmpsubs", ref, {
          maxRefDepth: 1,
        });

        this.tmpsubs.forEach((doc) => {
          this.langs.push(doc);
        });
        let length = this.tmpsubs.length;

        // Prevent from receiving updates automatically
        this.$unbind("tmpsubs", true);

        done(length == 0);
        // else this.$refs.scroller.stop();
      } catch (e) {
        console.log(e);
        this.showError(e);
      }
    },
  },
  firestore: {
    config: db.collection("config").doc("meta"),
  },
};
</script>
